﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;

namespace CBR.Core.Helpers
{
    public class MenuItemViewModel : ViewModelBase
    {
        #region ----------------CONSTRUCTOR----------------

        public MenuItemViewModel()
        {
        }

        public MenuItemViewModel( object data )
		{
            Data = data;
		}

		#endregion

        #region ----------------PROPERTIES----------------

        public string ToDisplay { get; set; }
        public bool IsEnabled { get; set; }
        public bool IsChecked { get; set; }
        
        #endregion

        #region ----------------COMMANDS----------------

        #region check command
        private ICommand checkCommand;
        public ICommand CheckCommand
        {
            get
            {
                if (checkCommand == null)
                    checkCommand = new DelegateCommand<string>(ExecCheckCommand,
                        delegate(string param)
                        {
                            return Data != null;
                        });
                return checkCommand;
            }
        }

        virtual protected void ExecCheckCommand(string param)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region generic command
        private ICommand genericCommand;
        public ICommand GenericCommand
        {
            get
            {
                if (genericCommand == null)
                    genericCommand = new DelegateCommand<string>(ExecCommand,
                        delegate(string param)
                        {
                            return Data != null;
                        });
                return genericCommand;
            }
        }

        void ExecCommand(string param)
        {
            Mediator.Instance.NotifyColleagues(ViewModelBaseMessages.MenuItemCommand, this.Data);
        }
        #endregion

        #endregion
    }
}
