﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using CBR.Core.Models;
using CBR.Core.Helpers;

namespace CBR.ViewModels
{
    class RecentFileInfoViewModel : ViewModelBase
    {
        #region ----------------CONSTRUCTOR----------------

        public RecentFileInfoViewModel(RecentFileInfo rfi)
		{
            if (rfi != null)
			{
                Data = rfi;
			}
		}

        new public RecentFileInfo Data
        {
            get { return base.Data as RecentFileInfo; }
            set { base.Data = value; }
        }

		#endregion

        public string FilePath
        {
            get { return Data.FilePath; }
            set { Data.FilePath = value; RaisePropertyChanged("FilePath"); }
        }

        public string FileName
        {
            get { return Data.FileName; }
            set { Data.FileName = value; RaisePropertyChanged("FileName"); }
        }

        public bool IsPined
        {
            get { return Data.IsPined; }
            set
            {
                Data.IsPined = value; RaisePropertyChanged("IsPined");
                Mediator.Instance.NotifyColleagues(ViewModelMessages.RecentFileChanged, Data);
            }
        }

        public DateTime LastAccess
        {
            get { return Data.LastAccess; }
            set
            {
                Data.LastAccess = value; RaisePropertyChanged("LastAcess");
                Mediator.Instance.NotifyColleagues(ViewModelMessages.RecentFileChanged, Data);
            }
        }
    }
}
